import ToolbarAnalytics from "../components/toolbar-analytics/ToolbarAnalytics";
import PsAccordion from "../components/accordion/Accordion";
import { CustomItem } from "../components/accordion/UIComponent";
import { FormPopup, FormTextbox, PsDataGrid } from "../components";
import { useCallback, useState } from "react";
import PsButton from "../components/button/Button";
import PsMenu from "../components/menu/Menu";
import { ProductItemType } from "../components/menu/types";

const companies = [
  {
    ID: 1,
    title: "Super Mart of the West",
    Address: "702 SW 8th Street",
    City: "Bentonville",
    State: "Arkansas",
    Zipcode: 72716,
    Phone: "(800) 555-2797",
    Fax: "(800) 555-2171",
    Website: "http://www.nowebsitesupermart.dx",
  },
  {
    ID: 2,
    title: "Electronics Depot",
    Address: "2455 Paces Ferry Road NW",
    City: "Atlanta",
    State: "Georgia",
    Zipcode: 30339,
    Phone: "(800) 595-3232",
    Fax: "(800) 595-3231",
    Website: "http://www.nowebsitedepot.dx",
  },
  {
    ID: 3,
    title: "K&S Music",
    Address: "1000 Nicllet Mall",
    City: "Minneapolis",
    State: "Minnesota",
    Zipcode: 55403,
    Phone: "(612) 304-6073",
    Fax: "(612) 304-6074",
    Website: "http://www.nowebsitemusic.dx",
  },
  {
    ID: 4,
    title: "Tom's Club",
    Address: "999 Lake Drive",
    City: "Issaquah",
    State: "Washington",
    Zipcode: 98027,
    Phone: "(800) 955-2292",
    Fax: "(800) 955-2293",
    Website: "http://www.nowebsitetomsclub.dx",
  },
];

const newContact = {
  name: "",
  phone: "",
};

const newPopupForm = {
  firstName: "",
  lastName: "",
};

const products = [
  {
    id: "1",
    name: "Video Players",
    items: [
      {
        id: "1_1",
        name: "HD Video Player",
        price: 220,
        icon: "images/products/1.png",
      },
      {
        id: "1_2",
        name: "SuperHD Video Player",
        icon: "images/products/2.png",
        price: 270,
      },
    ],
  },
  {
    id: "2",
    name: "Televisions",
    items: [
      {
        id: "2_1",
        name: "SuperLCD 42",
        icon: "images/products/7.png",
        price: 1200,
      },
      {
        id: "2_2",
        name: "SuperLED 42",
        icon: "images/products/5.png",
        price: 1450,
      },
      {
        id: "2_3",
        name: "SuperLED 50",
        icon: "images/products/4.png",
        price: 1600,
      },
      {
        id: "2_4",
        name: "SuperLCD 55 (Not available)",
        icon: "images/products/6.png",
        price: 1350,
        disabled: true,
      },
      {
        id: "2_5",
        name: "SuperLCD 70",
        icon: "images/products/9.png",
        price: 4000,
      },
    ],
  },
  {
    id: "3",
    name: "Monitors",
    items: [
      {
        id: "3_1",
        name: '19"',
        items: [
          {
            id: "3_1_1",
            name: "DesktopLCD 19",
            icon: "images/products/10.png",
            price: 160,
          },
        ],
      },
      {
        id: "3_2",
        name: '21"',
        items: [
          {
            id: "3_2_1",
            name: "DesktopLCD 21",
            icon: "images/products/12.png",
            price: 170,
          },
          {
            id: "3_2_2",
            name: "DesktopLED 21",
            icon: "images/products/13.png",
            price: 175,
          },
        ],
      },
    ],
  },
  {
    id: "4",
    name: "Projectors",
    items: [
      {
        id: "4_1",
        name: "Projector Plus",
        icon: "images/products/14.png",
        price: 550,
      },
      {
        id: "4_2",
        name: "Projector PlusHD",
        icon: "images/products/15.png",
        price: 750,
      },
    ],
  },
];

const columns = ['CompanyName', 'City', 'State', 'Phone', 'Fax'];

export const customers = [{
  ID: 1,
  CompanyName: 'Super Mart of the West',
  Address: '702 SW 8th Street',
  City: 'Bentonville',
  State: 'Arkansas',
  Zipcode: 72716,
  Phone: '(800) 555-2797',
  Fax: '(800) 555-2171',
}, {
  ID: 2,
  CompanyName: 'Electronics Depot',
  Address: '2455 Paces Ferry Road NW',
  City: 'Atlanta',
  State: 'Georgia',
  Zipcode: 30339,
  Phone: '(800) 595-3232',
  Fax: '(800) 595-3231',
}, {
  ID: 3,
  CompanyName: 'K&S Music',
  Address: '1000 Nicllet Mall',
  City: 'Minneapolis',
  State: 'Minnesota',
  Zipcode: 55403,
  Phone: '(612) 304-6073',
  Fax: '(612) 304-6074',
}, {
  ID: 4,
  CompanyName: "Tom's Club",
  Address: '999 Lake Drive',
  City: 'Issaquah',
  State: 'Washington',
  Zipcode: 98027,
  Phone: '(800) 955-2292',
  Fax: '(800) 955-2293',
}, {
  ID: 5,
  CompanyName: 'E-Mart',
  Address: '3333 Beverly Rd',
  City: 'Hoffman Estates',
  State: 'Illinois',
  Zipcode: 60179,
  Phone: '(847) 286-2500',
  Fax: '(847) 286-2501',
}, {
  ID: 6,
  CompanyName: 'Walters',
  Address: '200 Wilmot Rd',
  City: 'Deerfield',
  State: 'Illinois',
  Zipcode: 60015,
  Phone: '(847) 940-2500',
  Fax: '(847) 940-2501',
}, {
  ID: 7,
  CompanyName: 'StereoShack',
  Address: '400 Commerce S',
  City: 'Fort Worth',
  State: 'Texas',
  Zipcode: 76102,
  Phone: '(817) 820-0741',
  Fax: '(817) 820-0742',
}, {
  ID: 8,
  CompanyName: 'Circuit Town',
  Address: '2200 Kensington Court',
  City: 'Oak Brook',
  State: 'Illinois',
  Zipcode: 60523,
  Phone: '(800) 955-2929',
  Fax: '(800) 955-9392',
}, {
  ID: 9,
  CompanyName: 'Premier Buy',
  Address: '7601 Penn Avenue South',
  City: 'Richfield',
  State: 'Minnesota',
  Zipcode: 55423,
  Phone: '(612) 291-1000',
  Fax: '(612) 291-2001',
}, {
  ID: 10,
  CompanyName: 'ElectrixMax',
  Address: '263 Shuman Blvd',
  City: 'Naperville',
  State: 'Illinois',
  Zipcode: 60563,
  Phone: '(630) 438-7800',
  Fax: '(630) 438-7801',
}, {
  ID: 11,
  CompanyName: 'Video Emporium',
  Address: '1201 Elm Street',
  City: 'Dallas',
  State: 'Texas',
  Zipcode: 75270,
  Phone: '(214) 854-3000',
  Fax: '(214) 854-3001',
}, {
  ID: 12,
  CompanyName: 'Screen Shop',
  Address: '1000 Lowes Blvd',
  City: 'Mooresville',
  State: 'North Carolina',
  Zipcode: 28117,
  Phone: '(800) 445-6937',
  Fax: '(800) 445-6938',
}];

export default function MiddleWare() {
  const [newContactData, setNewContactData] = useState<any>({
    ...newContact,
  });

  const updateField = (field: string) => (value: any) => {
    setNewContactData({ ...newContactData, ...{ [field]: value } });
  };

  // form popup
  const [popupVisible, setPopupVisible] = useState(false);

  const changePopupVisibility = useCallback(() => {
    setPopupVisible(!popupVisible);
  }, [popupVisible]);

  const [newPopupData, setPopupData] = useState<any>({
    ...newPopupForm,
  });

  const updatePopupField = (field: string) => (value: any) => {
    setPopupData({ ...newPopupForm, ...{ [field]: value } });
  };

  const handleFormSubmit = useCallback(() => {
    console.log(newPopupData);
  }, [newPopupData]);

  // form popup end

  const itemClick = useCallback((itemData: ProductItemType) => {
    console.log(itemData);
  }, []);

  const title = () => {
    return (
      <h1>hello</h1>
    )
  }
  
  return (
    <>
      <ToolbarAnalytics title={"Demo"} />
      <PsAccordion dataSource={companies} Component={CustomItem} CustomTitle={title} />
      <FormTextbox
        label="Organization Name"
        value={newContactData.name}
        isEditing={false}
        onValueChange={updateField("name")}
      />
      {/* <DateDropDown onDateChange={function (data: any): void {
        throw new Error("Function not implemented.");
      } } data={[]} /> */}
      <FormTextbox
        value={newContactData.phone}
        isEditing={false}
        onValueChange={updateField("phone")}
        icon="tel"
        label="Phone"
        mask="+1(000)000-0000"
      />
      <PsButton text={"Submit"} onClick={() => console.log("submit")} />

      <PsButton text={"Popup Open"} onClick={changePopupVisibility} />
      <FormPopup
        title="New Client"
        visible={popupVisible}
        setVisible={changePopupVisibility}
        onSave={handleFormSubmit}
      >
        <FormTextbox
          label="First Name"
          value={newPopupForm.firstName}
          isEditing={false}
          onValueChange={updatePopupField("firstName")}
        />
        <FormTextbox
          label="Last Name"
          value={newPopupForm.lastName}
          isEditing={false}
          onValueChange={updatePopupField("lastName")}
        />
        <PsButton text={"Submit"} onClick={() => console.log("submit")} />
      </FormPopup>
      <PsMenu
        data={products}
        mode={"onClick"}
        displayExpr={"name"}
        orientation={"horizontal"}
        onItemClick={itemClick}
      />
      <PsDataGrid columns={columns} dataSource={customers} />
    </>
  );
}
